Bug 213717 - arping doesn't work on InfiniBand ipoib interfaces
arping doesn't work on InfiniBand ipoib interfaces
Product: Fedora
Classification: Fedora
Component: iputils (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Martin Bacovsky
Depends On:
  Show dependency treegraph
Reported: 2006-11-02 13:04 EST by Doug Ledford
Modified: 2007-11-30 17:11 EST (History)
0 users

See Also:
Fixed In Version: iputils-20070202-1.fc6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-04-03 12:52:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Fix for arping (4.59 KB, text/x-patch)
2006-11-02 13:04 EST, Doug Ledford
no flags Details

  None (edit)
Description Doug Ledford 2006-11-02 13:04:52 EST
Description of problem: As ipoib interfaces have a 20 byte hardware address, and
a broadcast address that isn't all 0xff, arping fails to send proper packets
over the wire.

How reproducible: 100%

Steps to Reproduce:
1. Setup a machine with ipoib interfaces
2. Run arping in any mode
Actual results: It sends no packets because it A) has the wrong hardware
address, B) has the wrong hardware broadcast address and C) passes the wrong
length for the sockaddr struct to both send_to() and recv_from().

Expected results: Should work.

Additional info:  The attached patch still has some debugging info embedded in
it, but it's pretty close to ready to go.  It corrects the problem by using a
"feature" of getsockname() whereby it will overrun the address field if you pass
a large enough buffer to it.  By allocating a double struct for extra padding,
we get the full address.  For the broadcast address, we use sysfs (which adds a
dependency on libsysfs into the arping binary).  We also fix up the length
arguments to recv_from and send_to for the interface.  Using this patch under
RHEL5, tcpdump confirms that the packets are sent over the wire correctly.
Comment 1 Doug Ledford 2006-11-02 13:04:52 EST
Created attachment 140162 [details]
Fix for arping
Comment 2 Martin Bacovsky 2007-04-03 12:52:19 EDT
This issue should be fixed in iputils-20070202-1.fc6

Note You need to log in before you can comment on or make changes to this bug.